/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of IDLBrowser.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#import "IDLMatrix.h"


@implementation IDLMatrix

- (void) mouseDown:(NSEvent*)e
{
    int row, col;
    NSPoint p = [self convertPoint:[e locationInWindow] fromView:nil];
    if([self getRow:&row column:&col forPoint:p]){
        int clickCount = [e clickCount];
        if(clickCount == 1){
            id cell = [self cellAtRow:row column:col];
            NSRect cellFrame = [self cellFrameAtRow:row column:col];
            BOOL rc = [cell trackMouse:e inRect:cellFrame ofView:self untilMouseUp:NO];
            if(rc){
                [self selectCellAtRow:row column:col];
				[[self window]makeFirstResponder:self];
                [self sendAction];
            }
        }else
        if(clickCount == 2)
            [self sendDoubleAction];
    }
}

- (BOOL)shouldDelayWindowOrderingForEvent:(NSEvent *)theEvent
{
    return YES;
}

@end
