/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of IDLBrowser.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#import <Foundation/Foundation.h>

@class IDLInterface, BindingItem;

@interface IDLNameService : NSObject 
{
    IDLInterface* _interface;
    id hostField;
    id portField;
    id iorView;
    id listCountField;
    id connectButton;
    id connectBox;
    id window;
    id table;
    id tableBox;
    id resolveButton;
    id reloadButton;
    id messageField;
    id giopPopUp;
    BindingItem* _dataSource;
}

+ nameService;
- (void) connect:sender;
- (void) list:sender;
- (void) orderFront:sender;
- (void) click:sender;
- (void) resolveItem:sender;
- (void) showTableView;
- (void) hideTableView;
- (void) reloadList:sender;
- (void) reloadContextList:sender;
- (void) presentException:(NSException*)exception;
@end
