/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of ADORB.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#import "QuoteItem.h"

@implementation QuoteItem

@synthesize _symbol;
@synthesize _name;
@synthesize _value;
@synthesize _volume;
@synthesize _market;

- init
{
    self = [super init];
    _market = @"NASDAQ";
    _value = 1;
    _volume = 1000000;
    return self;
}

- (void) dealloc
{
    [_symbol release];
    [_name release];
    [_market release];
    [super dealloc];
}

- initWithDictionary:dict
{
    id val;
    self = [self init];
    [self setValue:[dict valueForKey:@"symbol"] forKey:@"symbol"];
    [self setValue:[dict valueForKey:@"name"] forKey:@"name"];
    [self setValue:[dict valueForKey:@"market"] forKey:@"market"];
    if(val = [dict valueForKey:@"value"])
        _value = [val doubleValue];
    if(val = [dict valueForKey:@"volume"])
        _volume = [val doubleValue];
        
    return self;
}

- (BOOL) isEqual:(QuoteItem*)item
{
    return ([self class] == [item class] && [_symbol isEqualToString:item->_symbol]);
}

- (void) update
{
    long n = 1000000;
    double f = random()%n - 0.4*n;
    _value *= (1 + 0.05*f/n);
    f = random()%n - 0.4*n;
    _volume *= (1 + 0.08*f/n);
}

@end
