/*
 *  AdORB
 *  Copyright (C) 2006 Victor Ananiev
 *
 *  This file is part of ADORB.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#import "HelloWorldClient.h"
#import <ADORB/ORB.h>

@protocol HelloWorldIF
- (NSString*) helloWorld;
@end

@implementation HelloWorldClient

- init
{
    NSUserDefaults* defaults = [NSUserDefaults standardUserDefaults];
    // Get IOR file path from defaults
    NSString* iorPath = [defaults stringForKey:@"ior"];
    // Get the IOR from file
    NSString* ior = [[NSString alloc]initWithContentsOfFile:iorPath];
    self = [super init];
    // Get the object reference
    @try{
		server = [[CORBAObject objectWithIOR:ior]retain];
    }@catch(NSException *localException){
		NSLog(@"%@: %@\n", [localException name], [localException reason]);
    }
    return self;
}
- (void) dealloc
{
    [server release];
    [super dealloc];
}
- (void) run
{
    @try{
    // Send the message to server
    NSString* str = [server helloWorld];
    NSLog(@"Server returns: %@\n",str);
    NSLog(@"and: %@\n", [server helloWorld2]);
    }@catch(NSException *localException){
		NSLog(@"%@: %@\n", [localException name], [localException reason]);
    }
}
@end
